moDraw.amount = {};

function moDraw.amount:setOpenPdaSlot(self, slot, slotName)	
	if moFillTypes == nil or moFillTypes[1] == nil then
		moGuiExtras:closeOpenSlot(self, slot, true, false);
		g_currentMission:showBlinkingWarning(tostring(moLanguageXml:getTxt("slotno")), 2500);
		return;
	end;
	----	
	moGuiExtras:setSlotMaxProSwitch(self, slot);
	moGuiExtras:setSlotFirstEndObjects(self, slot);
	local farmSilo = moGeneralSettings.multiFarmSilo;
	local tablePos, moFillTypesSort = sortFillTypesAmount(self, slot, farmSilo);
	local firstObjectDisplay, endObjectDisplay = moGuiMiniPdaSlots.values[slot].firstObject, moGuiMiniPdaSlots.values[slot].endObject;
	local tempObjectDisplay = 0;
	----	
	local posX = moGuiMiniPdaSlots.values[slot].openX+0.001;
	local posY = moGuiMiniPdaSlots.values[slot].openY;
	local size = moGuiMiniPdaSlots.values[slot].size;
	local distanceLine = moGuiMiniPdaSlots.values[slot].distanceLine;
	local widthSettings = moSetGetGui.buttonGfxWidth1*moSetGetGui.zoomOutInTemp*4;
	local heightSettings = moSetGetGui.buttonGfxHeight1*moSetGetGui.zoomOutInTemp*4;	
	local height = moSetGetGui.buttonGfxHeight1*(size*1000);
	local heightDefault = moSetGetGui.buttonGfxHeight1*(size*1000);
	local distanceDif = moGuiMiniPdaSlots.values[slot].distanceDif; --fillcontainer <----> filllevel
	local slotLength = moSetGetGui.buttonGfxWidth1*(size*1000/1.5)*(moGuiMiniPdaSlots.values[slot].length+moSetGetGui.screenAspectRatio);	
	local width = slotLength+distanceDif;	
	local widthNext = 0;
	local currentPosY = posY;
	function nextLine(setHeight, posYnew, setLine, posYline, widthLine, heightLine, onlyLine)
		if setLine then
			moSetGetGui:setOverlay(self, moSetGetGui["designLine"], posX-0.001, currentPosY-(posYline), widthLine, heightLine);
			moSetGetGui["designLine"]:render();
			if onlyLine then return;end;
		end;		
		if setHeight then height = height+(heightDefault)+posYnew;end; --height+size+posNew;
		currentPosY = currentPosY-(heightDefault)-posYnew; --posY-(size+posYnew);		
	end;	
	moSetGetGui["designGround".. slot]:render();
	setTextBold(true);	
	setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
	local sizeTemp = 0.010;
	if size < sizeTemp then sizeTemp = size;end;
	if moGuiMiniPdaSlots.keySwitchLast == slot then
		if not moGuiMiniPdaSlots.values[slot].settings then
			moSetGetGui["slotCfg"]:setPosition(posX, posY);
			moSetGetGui["slotCfg"]:render();
		else
			moSetGetGui["slotPos"]:setPosition(posX, posY);
			moSetGetGui["slotPos"]:render();
		end;
		nextLine(true, 0.005, false);
		moSetGetGui["slotFruit"]:setPosition(posX+(widthSettings*1), posY);
		moSetGetGui["slotFruit"]:render();		
		if not moGuiMiniPdaSlots.values[slot].seeInOutFruit then
			moSetGetGui["slotNotOkay"]:setPosition(posX+(widthSettings*1), posY);
			moSetGetGui["slotNotOkay"]:render();
		end;
		moSetGetGui["slotMoney"]:setPosition(posX+(widthSettings*2), posY);
		moSetGetGui["slotMoney"]:render();		
		if not moGuiMiniPdaSlots.values[slot].seePrice then
			moSetGetGui["slotNotOkay"]:setPosition(posX+(widthSettings*2), posY);
			moSetGetGui["slotNotOkay"]:render();
		end;
		moSetGetGui["slotPlus"]:setPosition(posX+(widthSettings*3), posY);
		moSetGetGui["slotPlus"]:render();		
		if moGuiMiniPdaSlots.values[slot].seeSmall then
			moSetGetGui["slotNotOkay"]:setPosition(posX+(widthSettings*3), posY);
			moSetGetGui["slotNotOkay"]:render();
		end;
		--moSetGetGui["slotPlus"]:setPosition(posX+(widthSettings*3), posY);
		--moSetGetGui["slotPlus"]:render();		
		--moSetGetGui["slotNotReady"]:setPosition(posX+(widthSettings*3), posY);
		--moSetGetGui["slotNotReady"]:render();		
		moSetGetGui["slotSwitchL"]:setPosition(posX+(widthSettings*4), posY);
		moSetGetGui["slotSwitchL"]:render();
		renderText(posX+(widthSettings*4.7), posY+0.0035, sizeTemp, tostring(moGuiMiniPdaSlots.values[slot].switch));
		moSetGetGui["slotSwitchR"]:setPosition(posX+(widthSettings*5), posY);
		moSetGetGui["slotSwitchR"]:render();
		moSetGetGui["slotNextL"]:setPosition(posX+(widthSettings*6), posY);
		moSetGetGui["slotNextL"]:render();
		moSetGetGui["slotNextR"]:setPosition(posX+(widthSettings*8), posY);
		moSetGetGui["slotNextR"]:render();
		renderText(posX+(widthSettings*7.05), posY+0.0035, sizeTemp, tostring(moGuiMiniPdaSlots.values[slot].maxProSwitch));
		renderText(posX, currentPosY, size, tostring(moLanguageXml:getTxt("amount")).. ": ".. tostring(firstObjectDisplay).. "-".. tostring(endObjectDisplay));
	else
		moSetGetGui["slotNotReady"]:setPosition(posX, posY-(heightSettings));
		moSetGetGui["slotNotReady"]:render();
		nextLine(true, 0.005, false);
		renderText(posX, posY+0.0035, sizeTemp, "Slotname:  ".. tostring(moGuiMiniPdaSlots.values[slot].name));
		renderText(posX+(widthSettings), currentPosY, size, tostring(moLanguageXml:getTxt("amount")).. ": ".. tostring(firstObjectDisplay).. "-".. tostring(endObjectDisplay));
	end;	
	----	
	setTextAlignment(RenderText.ALIGN_RIGHT);
	setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
	renderText(posX+width-distanceDif, currentPosY, size, tostring(moGuiMiniPdaSlots.values[slot].foundObjects));		
	setTextAlignment(false);	
	nextLine(true, 0.007, true, 0.0035, width+widthNext, 0.001);
	local firstLine = false;
	----
	function nextFruitsLine(k, emptyFruit)
		setTextAlignment(false);
		if firstLine then nextLine(true, distanceLine, true, 0.0035, width+widthNext, 0.001);end;
		firstLine = true;
		if emptyFruit then 
			setTextColor(unpack(moGuiMiniPdaSlots.activeColor));
			setTextBold(true);
		else
			setTextColor(unpack(moGuiMiniPdaSlots.inactiveColor));
			setTextBold(false);
		end;
		if moGeneralSettings.foundGreatDemand > 0 and moFillTypes[k].greatDemandStation ~= nil then setTextColor(unpack(moGuiMiniPdaSlots.demandColor));end;
		if string.find(moFillTypes[k].fruitName, "!") then
			setTextColor(unpack(moGuiMiniPdaSlots.warningColor3));
			if moPalFillTypes[k] ~= nil then
				moSetGetGui["palFruit"]:setPosition(posX, currentPosY-0.0025);
				moSetGetGui["palFruit"]:render();
				renderText(posX+widthSettings, currentPosY, size, "!".. tostring(moFillTypes[k].descName));
			else
				renderText(posX, currentPosY, size, "!".. tostring(moFillTypes[k].descName));
			end;
		else
			if moPalFillTypes[k] ~= nil then
				moSetGetGui["palFruit"]:setPosition(posX, currentPosY-0.0025);
				moSetGetGui["palFruit"]:render();
				renderText(posX+widthSettings, currentPosY, size, tostring(moFillTypes[k].fruitName));
			else
				renderText(posX, currentPosY, size, tostring(moFillTypes[k].fruitName));
			end;			
		end;
		local amountTemp = g_i18n:formatNumber(Utils.getNoNil(moFillTypes[k].siloAmount[farmSilo],0)); --string.format("%1.0f", Utils.getNoNil(moFillTypes[k].siloAmount[farmSilo],0));					
		setTextAlignment(RenderText.ALIGN_RIGHT);
		if emptyFruit then 
			setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
			setTextBold(true);
		else
			setTextColor(unpack(moGuiMiniPdaSlots.inactiveColor));
			setTextBold(false);
		end;
		local pal = "";
		if moPalFillTypes[k] ~= nil and moPalFillTypes[k].pal ~= nil and moPalFillTypes[k].pal > 0 then pal = "(".. tostring(moPalFillTypes[k].pal).. ")";end;
		renderText(posX+width-distanceDif, currentPosY, size, tostring(amountTemp).. tostring(pal));				
		if moGuiMiniPdaSlots.values[slot].seePrice and moFillTypes[k].bestPrice ~= nil and moFillTypes[k].bestPrice > 0.01 then
			setTextAlignment(false);
			nextLine(true, distanceLine/2, false);
			setTextColor(unpack(moGuiMiniPdaSlots.warningColor1));			
			renderText(posX, currentPosY, size, tostring(moLanguageXml:getTxt("price", nil, "Price")));
			setTextAlignment(RenderText.ALIGN_RIGHT);
			if moGeneralSettings.foundGreatDemand > 0 and moFillTypes[k].greatDemandStation ~= nil then setTextColor(unpack(moGuiMiniPdaSlots.demandColor));end;
			local bestPrice = 0;
			if moFillTypes[k].greatDemandStationDescName ~= nil then
				bestPrice = moFillTypes[k].pricePerLiter*moFillTypes[k].stationPriceMulti[moFillTypes[k].greatDemandStationDescName.. " PriceMulti"]*moGeneralSettings.difficultyMultiplier*moFillTypes[k].greatDemandMultiplier*1000;
			else					
				bestPrice = moFillTypes[k].pricePerLiter*moFillTypes[k].bestPrice*moGeneralSettings.difficultyMultiplier*moFillTypes[k].greatDemandMultiplier*1000;					
			end;
			if string.find(moGeneralSettings.foundAnimals, moFillTypes[k].descName.. " ") then	
				if moFillTypes[k].greatDemandStationDescName ~= nil then
					bestPrice = moFillTypes[k].pricePerLiter/1000*moFillTypes[k].stationPriceMulti[moFillTypes[k].greatDemandStationDescName.. " PriceMulti"]*moGeneralSettings.difficultyMultiplier*moFillTypes[k].greatDemandMultiplier*1000;
				else						
					bestPrice = moFillTypes[k].pricePerLiter/1000*moFillTypes[k].bestPrice*moGeneralSettings.difficultyMultiplier*moFillTypes[k].greatDemandMultiplier*1000;						
				end;
			end;
			local bestPriceTemp = string.format("%.1f", Utils.getNoNil(bestPrice, 0));
			renderText(posX+width-distanceDif, currentPosY, size, tostring(bestPriceTemp).. " ".. tostring(moLanguageXml:getTxt("moneysymbol")));
			setTextAlignment(false);
		end;		
	end;
	if table.getn(moFillTypesSort) > 0 then		
		for a=1, table.getn(moFillTypesSort) do		
			tempObjectDisplay = tempObjectDisplay+1;
			if tonumber(tempObjectDisplay) >= tonumber(firstObjectDisplay) then				
				if tonumber(firstObjectDisplay) > tonumber(endObjectDisplay) then break;end;				
				firstObjectDisplay = firstObjectDisplay+1;
				if not moGuiMiniPdaSlots.values[slot].seeInOutFruit and tonumber(a) > tonumber(tablePos) then break;end;
				if tonumber(a) > tonumber(tablePos) then						
					if tonumber(moFillTypes[moFillTypesSort[a]].siloAmount[farmSilo]) <= 1 then 
						nextFruitsLine(moFillTypesSort[a], false);
					else
						nextFruitsLine(moFillTypesSort[a], true);
					end;					
				else						
					if tonumber(moFillTypes[moFillTypesSort[a]].siloAmount[farmSilo]) <= 1 then
						nextFruitsLine(moFillTypesSort[a], false);
					else
						nextFruitsLine(moFillTypesSort[a], true);
					end;							
				end;
			end;
		end;
		if moGuiMiniPdaSlots.values[slot].switch == 1 then
			moSetGetAmount:getNoFoundBaleAmount(self);
			if moBaleTypes ~= nil then		
				setTextBold(true);
				for k,v in pairs(moBaleTypes) do
					if k ~= nil then
						nextLine(true, distanceLine, true, 0.0035, width+widthNext, 0.001);
						setTextAlignment(false);
						setTextColor(unpack(moGuiMiniPdaSlots.activeColor));
						renderText(posX, currentPosY, size, moBaleTypes[k].name.. tostring(moLanguageXml:getTxt("bale")));										
						local amountTemp = string.format("%1.0f", Utils.getNoNil(moBaleTypes[k].amount,0));					
						setTextAlignment(RenderText.ALIGN_RIGHT);
						setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
						renderText(posX+width-distanceDif, currentPosY, size, tostring(amountTemp));												
					end;
				end;
			end;
		end;
		nextLine(true, 0, true, 0.0035, width+widthNext, 0.001);
	end;	
	----	
	moSetGetGui:setOverlay(self, moSetGetGui["designGround".. slot], posX-0.001, currentPosY+(heightSettings/2), width+widthNext, height+(heightSettings/2)); --+heightSettings	
	moGuiMiniPdaSlots.values[slot].openLastWidth = width+widthNext;
	moGuiMiniPdaSlots.values[slot].openLastHeight = height+(heightSettings/2); --+heightSettings	
	setTextColor(1, 1, 1, 1);
	setTextAlignment(false);
	setTextBold(false);	
end;

function sortFillTypesAmount(self, slot)
	local fillTypesSort = {};
	local tablePos = 0;	
	function setNextTable(k, nextTablePos)
		if nextTablePos then tablePos = tablePos+1;end;
		table.insert(fillTypesSort, tablePos, k);			
	end;		
	for k,v in pairs(moFillTypes) do			
		local emptyFruit = moSetGetAmount:getNoFoundSiloAmount(k);			
		--local desc = Fillable.fillTypeIndexToDesc[k];
		if not emptyFruit and moPalFillTypes[k] ~= nil then emptyFruit = true;end;
		--new fix straw grass windrow hay fuel double
		local doubleFound = false;
		if not moGeneralSettings.fruitsDoubleNames then
			if moFillTypes[k].fuel and moFillTypes[k].descName ~= tostring(moGeneralSettings.masterFuelFruit) then doubleFound = true;end;
			if moFillTypes[k].grass and moFillTypes[k].descName ~= tostring(moGeneralSettings.masterGrassFruit) then doubleFound = true;end;
			if moFillTypes[k].hay and moFillTypes[k].descName ~= tostring(moGeneralSettings.masterHayFruit) then doubleFound = true;end;
			if moFillTypes[k].windrow and moFillTypes[k].descName ~= tostring(moGeneralSettings.masterWindrowFruit) then doubleFound = true;end;
			if moFillTypes[k].kalk and moFillTypes[k].descName ~= tostring(moGeneralSettings.masterKalkFruit) then doubleFound = true;end;
			if moFillTypes[k].manure and moFillTypes[k].descName ~= tostring(moGeneralSettings.masterManureFruit) then doubleFound = true;end;
			if moFillTypes[k].liquid and moFillTypes[k].descName ~= tostring(moGeneralSettings.masterLiquidFruit) then doubleFound = true;end;
		end;
		if not doubleFound then
		--new fix straw grass windrow hay fuel double
			if moGuiMiniPdaSlots.values[slot].seeInOutFruit then
				if emptyFruit then					
					if moGuiMiniPdaSlots.values[slot].seeSmall then
						if tonumber(moFillTypes[k].bestPrice) > 0 and tonumber(moFillTypes[k].pricePerLiter) > 0 then setNextTable(k, true);end;
					else
						setNextTable(k, true);												
					end;
				else
					if moGuiMiniPdaSlots.values[slot].seeSmall then
						if tonumber(moFillTypes[k].bestPrice) > 0 and tonumber(moFillTypes[k].pricePerLiter) > 0 then setNextTable(k, false);end;
					else
						setNextTable(k, false);						
					end;
				end;
			else
				if emptyFruit then
					if moGuiMiniPdaSlots.values[slot].seeSmall then
						if tonumber(moFillTypes[k].bestPrice) > 0 and tonumber(moFillTypes[k].pricePerLiter) > 0 then setNextTable(k, true);end;						
					else					
						setNextTable(k, true);
					end;					
				end;
			end;
		end;
	end;
	return tablePos, fillTypesSort;
end;